import * as i0 from '@angular/core';
import { EventEmitter, Component, Output, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { UntypedFormControl, Validators, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

var data = [
    {
        countryName: "India",
        countryCode: "+91",
        flag: "https://cdn.countryflags.com/thumbs/india/flag-400.png",
        mobile_format: "9999-999999"
    },
    {
        countryName: "Brunei",
        countryCode: "+673",
        flag: "https://cdn.countryflags.com/thumbs/brunei/flag-400.png",
        mobile_format: "999-9999-999"
    },
    {
        countryName: "Laos",
        countryCode: "+856",
        flag: "https://cdn.countryflags.com/thumbs/laos/flag-400.png",
        mobile_format: "99-999999"
    },
    {
        countryName: "Cambodia",
        countryCode: "+855",
        flag: "https://cdn.countryflags.com/thumbs/cambodia/flag-400.png",
        mobile_format: "99-999-999"
    },
    {
        countryName: "Hong Kong",
        countryCode: "+852",
        flag: "https://cdn.countryflags.com/thumbs/hongkong/flag-400.png",
        mobile_format: "9999-9999"
    },
    {
        countryName: "Indonesia",
        countryCode: "+62",
        flag: "https://cdn.countryflags.com/thumbs/indonesia/flag-400.png",
        mobile_format: "9999-9999"
    },
    {
        countryName: "South Korea",
        countryCode: "+82",
        flag: "https://cdn.countryflags.com/thumbs/south-korea/flag-400.png",
        mobile_format: "99-999-9999"
    },
    {
        countryName: "Malaysia",
        countryCode: "+60",
        flag: "https://cdn.countryflags.com/thumbs/malaysia/flag-400.png",
        mobile_format: "99-999-9999"
    },
    {
        countryName: "Philippines",
        countryCode: "+63",
        flag: "https://cdn.countryflags.com/thumbs/philippines/flag-400.png",
        mobile_format: "9999-999-9999"
    },
    {
        countryName: "Singapore",
        countryCode: "+65",
        flag: "https://cdn.countryflags.com/thumbs/singapore/flag-400.png",
        mobile_format: "9999-9999"
    },
    {
        countryName: "Thailand",
        countryCode: "+66",
        flag: "https://cdn.countryflags.com/thumbs/thailand/flag-400.png",
        mobile_format: "9-9999999"
    },
    {
        countryName: "Vietnam",
        countryCode: "+84",
        flag: "https://cdn.countryflags.com/thumbs/vietnam/flag-400.png",
        mobile_format: "9999-999-9999"
    },
    {
        countryName: "Taiwan",
        countryCode: "+886",
        flag: "https://cdn.countryflags.com/thumbs/taiwan/flag-400.png",
        mobile_format: "999999999"
    }
];

class SCountryFlagInputComponent {
    constructor(_formBuilder) {
        this._formBuilder = _formBuilder;
        this.showFlags = false;
        this.countriesData = data;
        this.defaultCountry = {
            countryName: 'India',
            countryCode: '+91',
            flag: 'https://cdn.countryflags.com/thumbs/india/flag-400.png',
            mobile_format: "9999-999999"
        };
        this.flagdata = new EventEmitter();
        this.phoneNumberInput = new EventEmitter();
    }
    ngOnInit() {
        this.flagComponentForm = this._formBuilder.group({
            phonenumber: new UntypedFormControl(''),
        });
        this.flagComponentForm.controls['phonenumber'].setValidators([
            Validators.required,
            Validators.pattern('^((\\+91-?)|0)?[0-9]{10}$'),
            Validators.minLength(5),
        ]);
    }
    onClickFlag() {
        if (this.disableInput == false) {
            this.showFlags = true;
        }
    }
    getCountryDetails(data) {
        this.flagdata.emit({ value: data });
        this.showFlags = false;
        this.defaultCountry = data;
    }
    ngDoCheck() {
        this.phoneNumberInput.emit(this.flagComponentForm.controls['phonenumber']);
    }
    getMobileNumber(event) {
        return ((event.code.includes('Digit') && event.shiftKey === false) ||
            event.code.includes('Numpad1') ||
            event.code.includes('Numpad2') ||
            event.code.includes('Numpad3') ||
            event.code.includes('Numpad4') ||
            event.code.includes('Numpad5') ||
            event.code.includes('Numpad6') ||
            event.code.includes('Numpad7') ||
            event.code.includes('Numpad8') ||
            event.code.includes('Numpad9'));
    }
    ngOnChanges() {
        if (this.disableInput === true) {
            console.log(this.disableInput);
            this.flagComponentForm.disable();
        }
        else if (this.disableInput === false) {
            console.log(this.disableInput);
            this.flagComponentForm.enable();
        }
        this.phonenumber = this.autoFetchInput;
    }
}
SCountryFlagInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputComponent, deps: [{ token: i1.UntypedFormBuilder }], target: i0.ɵɵFactoryTarget.Component });
SCountryFlagInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: SCountryFlagInputComponent, selector: "s-country-flag-input", inputs: { disableInput: "disableInput", autoFetchInput: "autoFetchInput" }, outputs: { flagdata: "flagdata", phoneNumberInput: "phoneNumberInput" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"row mx-auto\">\r\n  <div class=\"col-md-2 col-sm-2 col-2 padding-0\">\r\n    <div class=\"box border-right-0\">\r\n      <div\r\n        (click)=\"onClickFlag()\"\r\n        class=\"\r\n          flag-box\r\n          border-right-0\r\n          d-flex\r\n          flex-column\r\n          justify-content-center\r\n          align-items-center\r\n        \"\r\n      >\r\n        <img\r\n          class=\"flagCala\"\r\n          [src]=\"defaultCountry.flag\"\r\n          style=\"padding-right: 10px; height: 10px;\"\r\n        />\r\n      </div>\r\n      <div id=\"myDropdown\" class=\"dropdown-content\" [hidden]=\"!showFlags\">\r\n        <div\r\n          *ngFor=\"let codes of countriesData\"\r\n          (click)=\"getCountryDetails(codes)\"\r\n          class=\"flag-detail\"\r\n        >\r\n          <img\r\n            [src]=\"codes.flag\"\r\n            style=\"padding-right: 10px; height: 10px; width: 30px;\"\r\n          />\r\n          {{ codes.countryName\r\n          }}<span class=\"cnt_cde\">{{ codes.countryCode }}</span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"col-md-10 col-sm-10 col-10 padding-0\">\r\n    <form [formGroup]=\"flagComponentForm\">\r\n      <input\r\n      type=\"tel\"\r\n      class=\"form-control border-left-0\"\r\n      id=\"phoneflag\"\r\n      formControlName=\"phonenumber\"\r\n      minlength=\"5\"\r\n      required\r\n      placeholder=\"{{defaultCountry.mobile_format}}\"\r\n      (keypress)=\"getMobileNumber($event)\"\r\n      [(ngModel)]=\"phonenumber\"\r\n    />\r\n    </form>\r\n  </div>\r\n</div>\r\n\r\n  ", styles: [".padding-0{padding-right:0;padding-left:0}.dropbtn{background-color:#3498db;color:#fff;padding:16px;font-size:16px;border:none;cursor:pointer}.dropbtn:hover,.dropbtn:focus{background-color:#2980b9;cursor:pointer}.dropdown{position:relative;display:inline-block}.dropdown-content{position:absolute;z-index:2;list-style:none;text-align:left;padding:0;margin:0;box-shadow:2px 3px 15px #0a0a0a2e;background-color:#fff;border:1px solid #fff;white-space:nowrap;max-height:200px;overflow-y:scroll}.dropdown-content div{color:#000;padding:12px 11px 0 12px;text-decoration:none;display:block}.flag{height:20px;width:20px}.dropdown div:hover{background-color:#ddd;cursor:pointer}.flag-box{display:block;width:100%;height:38px;font-size:1rem;justify-content:center;font-weight:400;line-height:1.5;background-clip:padding-box;-webkit-appearance:none;-moz-appearance:none;color:#000;appearance:none;border-radius:.25rem 0rem 0rem .25rem!important;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;background-color:#fff;background-position:20px 0;background-image:url(data:image/svg+xml;charset=US-ASCII,%3Csvg%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20viewBox%3D%220%200%20256%20448%22%20enable-background%3D%22new%200%200%20256%20448%22%3E%3Cstyle%20type%3D%22text%2Fcss%22%3E.arrow%7Bfill%3A%23424242%3B%7D%3C%2Fstyle%3E%3Cpath%20class%3D%22arrow%22%20d%3D%22M255.9%20168c0-4.2-1.6-7.9-4.8-11.2-3.2-3.2-6.9-4.8-11.2-4.8H16c-4.2%200-7.9%201.6-11.2%204.8S0%20163.8%200%20168c0%204.4%201.6%208.2%204.8%2011.4l112%20112c3.1%203.1%206.8%204.6%2011.2%204.6%204.4%200%208.2-1.5%2011.4-4.6l112-112c3-3.2%204.5-7%204.5-11.4z%22%2F%3E%3C%2Fsvg%3E%0A);background-position:right 0px center;background-repeat:no-repeat;background-size:auto 30%;border:1px solid #ced4da;padding-right:18px;padding-left:2px;-webkit-border-top-right-radius:0px;-webkit-border-bottom-right-radius:0px;-moz-border-radius-topright:0px;-moz-border-radius-bottomright:0px;border-top-right-radius:0;border-bottom-right-radius:0;border-left:3px #3e8ddd solid!important}.flag-detail:hover{background-color:#f6f6f6;padding:3px;cursor:pointer}.flag-detail{padding:3px}.box{height:100%}.border-right-0{border-right:none!important}.border-left-0{border-left:none!important;border-radius:0rem .25rem .25rem 0rem!important}.flag-box:hover{background-color:#f2f2f2;cursor:pointer}.padding-right-10{padding-right:10px}.cnt_cde{color:#999;padding-left:10px}.input-phone{-webkit-border-top-left-radius:0px;-webkit-border-bottom-left-radius:0px;-moz-border-radius-topleft:0px;-moz-border-radius-bottomleft:0px;border-top-left-radius:0;border-bottom-left-radius:0}.flagCala{width:45px!important;padding-left:2px!important;height:25px!important;padding-top:4px!important}@media (max-width: 1187px){.flagCala{width:30px!important;padding-left:10px!important}}@media (max-width: 985px){.flagCala{width:40px!important}}@media (max-width: 445px){.flagCala{width:40px!important}}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 's-country-flag-input', template: "<div class=\"row mx-auto\">\r\n  <div class=\"col-md-2 col-sm-2 col-2 padding-0\">\r\n    <div class=\"box border-right-0\">\r\n      <div\r\n        (click)=\"onClickFlag()\"\r\n        class=\"\r\n          flag-box\r\n          border-right-0\r\n          d-flex\r\n          flex-column\r\n          justify-content-center\r\n          align-items-center\r\n        \"\r\n      >\r\n        <img\r\n          class=\"flagCala\"\r\n          [src]=\"defaultCountry.flag\"\r\n          style=\"padding-right: 10px; height: 10px;\"\r\n        />\r\n      </div>\r\n      <div id=\"myDropdown\" class=\"dropdown-content\" [hidden]=\"!showFlags\">\r\n        <div\r\n          *ngFor=\"let codes of countriesData\"\r\n          (click)=\"getCountryDetails(codes)\"\r\n          class=\"flag-detail\"\r\n        >\r\n          <img\r\n            [src]=\"codes.flag\"\r\n            style=\"padding-right: 10px; height: 10px; width: 30px;\"\r\n          />\r\n          {{ codes.countryName\r\n          }}<span class=\"cnt_cde\">{{ codes.countryCode }}</span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"col-md-10 col-sm-10 col-10 padding-0\">\r\n    <form [formGroup]=\"flagComponentForm\">\r\n      <input\r\n      type=\"tel\"\r\n      class=\"form-control border-left-0\"\r\n      id=\"phoneflag\"\r\n      formControlName=\"phonenumber\"\r\n      minlength=\"5\"\r\n      required\r\n      placeholder=\"{{defaultCountry.mobile_format}}\"\r\n      (keypress)=\"getMobileNumber($event)\"\r\n      [(ngModel)]=\"phonenumber\"\r\n    />\r\n    </form>\r\n  </div>\r\n</div>\r\n\r\n  ", styles: [".padding-0{padding-right:0;padding-left:0}.dropbtn{background-color:#3498db;color:#fff;padding:16px;font-size:16px;border:none;cursor:pointer}.dropbtn:hover,.dropbtn:focus{background-color:#2980b9;cursor:pointer}.dropdown{position:relative;display:inline-block}.dropdown-content{position:absolute;z-index:2;list-style:none;text-align:left;padding:0;margin:0;box-shadow:2px 3px 15px #0a0a0a2e;background-color:#fff;border:1px solid #fff;white-space:nowrap;max-height:200px;overflow-y:scroll}.dropdown-content div{color:#000;padding:12px 11px 0 12px;text-decoration:none;display:block}.flag{height:20px;width:20px}.dropdown div:hover{background-color:#ddd;cursor:pointer}.flag-box{display:block;width:100%;height:38px;font-size:1rem;justify-content:center;font-weight:400;line-height:1.5;background-clip:padding-box;-webkit-appearance:none;-moz-appearance:none;color:#000;appearance:none;border-radius:.25rem 0rem 0rem .25rem!important;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;background-color:#fff;background-position:20px 0;background-image:url(data:image/svg+xml;charset=US-ASCII,%3Csvg%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20viewBox%3D%220%200%20256%20448%22%20enable-background%3D%22new%200%200%20256%20448%22%3E%3Cstyle%20type%3D%22text%2Fcss%22%3E.arrow%7Bfill%3A%23424242%3B%7D%3C%2Fstyle%3E%3Cpath%20class%3D%22arrow%22%20d%3D%22M255.9%20168c0-4.2-1.6-7.9-4.8-11.2-3.2-3.2-6.9-4.8-11.2-4.8H16c-4.2%200-7.9%201.6-11.2%204.8S0%20163.8%200%20168c0%204.4%201.6%208.2%204.8%2011.4l112%20112c3.1%203.1%206.8%204.6%2011.2%204.6%204.4%200%208.2-1.5%2011.4-4.6l112-112c3-3.2%204.5-7%204.5-11.4z%22%2F%3E%3C%2Fsvg%3E%0A);background-position:right 0px center;background-repeat:no-repeat;background-size:auto 30%;border:1px solid #ced4da;padding-right:18px;padding-left:2px;-webkit-border-top-right-radius:0px;-webkit-border-bottom-right-radius:0px;-moz-border-radius-topright:0px;-moz-border-radius-bottomright:0px;border-top-right-radius:0;border-bottom-right-radius:0;border-left:3px #3e8ddd solid!important}.flag-detail:hover{background-color:#f6f6f6;padding:3px;cursor:pointer}.flag-detail{padding:3px}.box{height:100%}.border-right-0{border-right:none!important}.border-left-0{border-left:none!important;border-radius:0rem .25rem .25rem 0rem!important}.flag-box:hover{background-color:#f2f2f2;cursor:pointer}.padding-right-10{padding-right:10px}.cnt_cde{color:#999;padding-left:10px}.input-phone{-webkit-border-top-left-radius:0px;-webkit-border-bottom-left-radius:0px;-moz-border-radius-topleft:0px;-moz-border-radius-bottomleft:0px;border-top-left-radius:0;border-bottom-left-radius:0}.flagCala{width:45px!important;padding-left:2px!important;height:25px!important;padding-top:4px!important}@media (max-width: 1187px){.flagCala{width:30px!important;padding-left:10px!important}}@media (max-width: 985px){.flagCala{width:40px!important}}@media (max-width: 445px){.flagCala{width:40px!important}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.UntypedFormBuilder }]; }, propDecorators: { flagdata: [{
                type: Output
            }], phoneNumberInput: [{
                type: Output
            }], disableInput: [{
                type: Input
            }], autoFetchInput: [{
                type: Input
            }] } });

class SCountryFlagInputModule {
}
SCountryFlagInputModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SCountryFlagInputModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputModule, declarations: [SCountryFlagInputComponent], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule], exports: [SCountryFlagInputComponent] });
SCountryFlagInputModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputModule, imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SCountryFlagInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        SCountryFlagInputComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    exports: [
                        SCountryFlagInputComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of flag-component
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SCountryFlagInputComponent, SCountryFlagInputModule };
//# sourceMappingURL=s-flag-input.mjs.map
